# Referenceables

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://tkf.github.io/Referenceables.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://tkf.github.io/Referenceables.jl/dev)
[![Build Status](https://travis-ci.com/tkf/Referenceables.jl.svg?branch=master)](https://travis-ci.com/tkf/Referenceables.jl)
[![Codecov](https://codecov.io/gh/tkf/Referenceables.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/tkf/Referenceables.jl)
[![Coveralls](https://coveralls.io/repos/github/tkf/Referenceables.jl/badge.svg?branch=master)](https://coveralls.io/github/tkf/Referenceables.jl?branch=master)

Referenceables.jl provides an interface for readable and writable
reference to an element of an array or dictionary.  The entry point
function is `referenceable`.  Wrapping a container `x` yields a new
view `y = referenceable(x)` to `x` where indexing to it yields a
reference `r = y[i]`.  This reference can be used to read `value =
r[]` or write `r[] = value` a value.

## Examples

```julia
julia> using Referenceables

julia> x = collect(reshape(1:6, (2, 3)))
       y = referenceable(x);

julia> r = y[1, 1] :: Ref
↪1

julia> r[] = 100;

julia> x
2×3 Array{Int64,2}:
 100  3  5
   2  4  6
```

module TestDict

using Referenceables
using Referenceables: isreferenceable
using Test

@testset begin
    x = Dict()
    y = referenceable(x)
    r = y[1]
    r[] = 10
    @test x[1] == 10
    @test y[1] isa valtype(y)
    @test y[1.0] isa valtype(y)
end

@testset "keytype" begin
    x = Dict{Int,Int}(1 => 1)
    y = referenceable(x)
    @test y[1] isa valtype(y)
    @test y[1.0] isa valtype(y)
end

@testset "isreferenceable" begin
    x = Dict()
    @test isreferenceable(referenceable(x))
    @test !isreferenceable(x)
end

end  # module

module TestAdapt

using Adapt
using Referenceables: Referenceable, referenceable
using Test

struct Incrementer end

Adapt.adapt_storage(::Incrementer, xs::AbstractArray) = xs .+ 1
Adapt.adapt_storage(::Incrementer, xs::Dict) = Dict(k => v + 1 for (k, v) in xs)

adapt_inc(xs::Referenceable) = parent(adapt(Incrementer(), xs)::Referenceable)

@testset begin
    @test adapt_inc(referenceable([1, 2, 3])) == 2:4
    @test adapt_inc(referenceable(Dict('a':'c' .=> 1:3))) == Dict('a':'c' .=> 2:4)
end

end  # module

module TestArray

using Referenceables
using Referenceables: isreferenceable
using Test

@testset begin
    x = collect(reshape(1:6, (2, 3)))
    y = referenceable(x)
    r1 = y[1]
    r1[] = r1[] * 10
    @test x[1] == 10

    r12 = y[1, 2]
    r12[] = r12[] * 10
    @test x[1, 2] == 30
end

@testset "eachindex" begin
    @testset for x in [
        ones(3),
        ones(2, 2),
    ]
        @test eachindex(x) == eachindex(x, referenceable(x))
    end
end

@testset "isreferenceable" begin
    x = collect(reshape(1:6, (2, 3)))
    @test isreferenceable(referenceable(x))
    @test isreferenceable(collect(referenceable(x)))
    @test isreferenceable(view(referenceable(x), 1:1, 1:2))
    @test isreferenceable(view(referenceable(x), 1:1))
    @test !isreferenceable(x)
    @test !isreferenceable(1:1)
end

end  # module

module Referenceables

export referenceable

import Adapt

# Use markdown files as the docstring:
for (name, path) in [
    :Referenceables => joinpath(dirname(@__DIR__), "README.md"),
    :referenceable => joinpath(@__DIR__, "referenceable.md"),
]
    include_dependency(path)
    str = replace(read(path, String), "```julia" => "```jldoctest $name")
    @eval @doc $str $name
end

"""
    RefIndexable{inbounds}(x, i::Tuple) where {inbounds isa Bool} <: Ref{valtype(x)}

Like `Base.RefArray`, but works with arbitrary containers and indices.
"""
struct RefIndexable{inbounds,T,A,I} <: Ref{T}
    x::A
    i::I
end

struct ReferenceableArray{T,N,A<:AbstractArray{T,N}} <:
       AbstractArray{RefIndexable{inbounds,T,A} where inbounds,N}
    x::A
end

Base.parent(x::ReferenceableArray) = x.x
parenttype(::Type{<:ReferenceableArray{<:Any, <:Any, A}}) where A = A

struct ReferenceableDict{K,V,A<:AbstractDict{K,V}} <:
       AbstractDict{K,RefIndexable{false,V,A,K}}
    x::A
end

Base.parent(x::ReferenceableDict) = x.x
parenttype(::Type{<:ReferenceableDict{<:Any, <:Any, A}}) where A = A

RefIndexable{inbounds}(x, i) where {inbounds} =
    RefIndexable{inbounds, _valtype(x), typeof(x), typeof(i)}(x, i)

RefIndexable(x, i) = RefIndexable{false}(x, i)

RefIndexable{inbounds}(x, i, ::Type{K}) where {inbounds, K} =
    RefIndexable{inbounds, _valtype(x), typeof(x), K}(x, i)

RefIndexable(x, i, ::Type{K}) where {K} = RefIndexable{false}(x, i, K)

Base.show(io::IO, x::RefIndexable) =
    if get(io, :limit, false)
        print(io, '↪', x[])
    else
        Base.show_default(io, x)
    end

@inline Base.getindex(x::RefIndexable{inbounds}) where {inbounds} =
    if inbounds
        @inbounds x.x[x.i...]
    else
        x.x[x.i...]
    end

@inline Base.setindex!(x::RefIndexable{inbounds}, value) where {inbounds} =
    if inbounds
        @inbounds x.x[x.i...] = value
    else
        x.x[x.i...] = value
    end

const Referenceable = Union{ReferenceableArray, ReferenceableDict}

@inline function Base.getindex(x::ReferenceableArray, i::Int...)
    @boundscheck checkbounds(x, i...)
    return RefIndexable{true}(x.x, i)
end

@inline function Base.getindex(x::ReferenceableDict{K}, i) where {K}
    return RefIndexable(x.x, convert(K, i), K)
end

referenceable(x::AbstractArray) = ReferenceableArray(x)
referenceable(x::AbstractDict) = ReferenceableDict(x)

Base.size(A::ReferenceableArray) = size(A.x)
Base.axes(A::ReferenceableArray) = axes(A.x)
Base.IndexStyle(::Type{A}) where {A <: ReferenceableArray} =
    Base.IndexStyle(parenttype(A))

Base.length(A::ReferenceableDict) = length(A.x)
Base.iterate(A::ReferenceableDict) = iterate(A.x)
Base.iterate(A::ReferenceableDict, state) = iterate(A.x, state)

isreferenceable(xs) = _valtype(xs) <: RefIndexable
_valtype(xs) = valtype(xs)
_valtype(xs::AbstractArray) = eltype(xs)  # for old Julia

Adapt.adapt_structure(to, x::Referenceable) = referenceable(Adapt.adapt(to, parent(x)))

end # module

using Documenter, Referenceables

makedocs(;
    modules=[Referenceables],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
        hide("internals.md"),
    ],
    repo="https://github.com/tkf/Referenceables.jl/blob/{commit}{path}#L{line}",
    sitename="Referenceables.jl",
    authors="Takafumi Arakaki <aka.tkf@gmail.com>",
)

deploydocs(;
    repo="github.com/tkf/Referenceables.jl",
)

module TestReferenceables
using Test

@testset "$file" for file in sort([file for file in readdir(@__DIR__) if
                                   match(r"^test_.*\.jl$", file) !== nothing])
    include(file)
end

end  # module

    referenceable(x::AbstractArray{T}) :: AbstractArray{<:Ref{T}}
    referenceable(x::AbstractDict{K, V}) :: AbstractDict{K, <:Ref{V}}

`referenceable(x)` converts a collection `x` to a wrapped container where
indexing to it produces a reference, not the value.

```julia
julia> using Referenceables

julia> x = collect(reshape(1:6, (2, 3)))
       y = referenceable(x);

julia> r = y[1] :: Ref
↪1

julia> r[] = 100;

julia> x
2×3 Array{Int64,2}:
 100  3  5
   2  4  6
```

!!! warning

    Inbound check is done when indexing the `referenceable(x)`
    container, _not_ during de-referencing `r[]`.  It means that
    passing the reference `r` to unknown code can result in a
    segmentation fault if the original container `x` is mutated
    afterwards.

`referenceable` works with dictionaries as well:

```julia
julia> x = Dict()
       y = referenceable(x);

julia> r = y[1] :: Ref
       r[] = 100;

julia> x
Dict{Any,Any} with 1 entry:
  1 => 100
```
